<script lang="ts">
    import { createEventDispatcher } from 'svelte'
    export let numberOfQuestions: number
    export let timePerQuestion: number
    export let operations: ('+' | '-' | '*' | '/')[]
    export let hasParenthesis: boolean
    const dispatch = createEventDispatcher()

    function dispatchNewSettings () {
      const params = { hasParenthesis, numberOfQuestions, timePerQuestion, operations }
      const url = new URL(window.location.href)
      url.searchParams.set('params', JSON.stringify(params))
      window.history.replaceState({}, '', url.toString())
      dispatch('settingsHasChanged', {
        numberOfQuestions,
        timePerQuestion,
        operations,
        hasParenthesis
      })
    }

</script>

<div class="my-5 flex flex-row flex-wrap gap-4">
    <div class="basis-36">
      <h1>Nombre de questions</h1>

      <form on:change={dispatchNewSettings}>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={5} />
            Cinq questions
          </label>
        </div>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={10} />
            Dix questions
          </label>
        </div>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={20} />
            Vingt questions
          </label>
        </div>
      </form>
    </div>
    <div class="basis-36">
      <h1>Temps par question</h1>
      <input type="number" min="1" max="60" step="1" class="w-24 h-10 px-2 border-2 rounded-md" bind:value={timePerQuestion} on:change={dispatchNewSettings} />    </div>
    <div class="basis-36">
      <h1>Opérations</h1>
      <form on:change={dispatchNewSettings}>
        <div>
          <label>
            <input type="checkbox" name="operations" value={'+'} bind:group={operations} />
            Addition
          </label>
        </div>
        <div>
          <label>
            <input type="checkbox" name="typeQuestionstion" value={'-'} bind:group={operations}/>
            Soustraction
          </label>
        </div>
        <div>
          <label>
            <input
              type="checkbox"
              name="operations"
              value={'*'}
              bind:group={operations}
            />
            Multiplication
          </label>
        </div>
        <div>
          <label>
            <input
              type="checkbox"
              name="operations"
              value={'/'}
              bind:group={operations}
            />
            Division
          </label>
        </div>
      </form>
    </div>
    <div class="basis-1/4">
      <h1>Écriture simplifiée</h1>
      <form on:change={dispatchNewSettings}>
        <div>
          <label>
            <input type="radio" name="operations" value={false} bind:group={hasParenthesis} />
            Oui
          </label>
        </div>
        <div>
          <label>
            <input type="radio" name="typeQuestionstion" value={true} bind:group={hasParenthesis}/>
            Non
          </label>
        </div>
    </div>
  </div>

  <style>
    :global(h1) {
    @apply text-xl;
    @apply text-[#216D9A];
    @apply font-bold;
  }
  </style>
